INTERRUPT	equ	16h
INT_SEG		equ	3909h		; SEG:OFF of instruction after the
INT_OFF		equ	0306h		; calling interrupt
CHANGE_SEG	equ	12C7h		; SEG:OFF of instruction to change
CHANGE_OFF	equ	3BFAh

OVERLAY	SEGMENT para 'code'
	ASSUME CS:OVERLAY,DS:OVERLAY
	ORG 100h

START:JMP INITCODE

;----------------------------------------------------------

OLDINT	DW	0,0
ADDR_OFF	equ	<word ptr[bp+2]>
ADDR_SEG	equ	<word ptr[bp+4]>

CR		equ	0Dh
LF		equ	0Ah
BEEP		equ	07h
EOS		equ	'$'

DISPLACEMENT	equ	CHANGE_SEG - INT_SEG

;----------------------------------------------------------

NEWINT proc far
	PUSH	BP
	MOV	BP,SP
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DI
	PUSH	DS
	PUSH	ES

	MOV	AX,ADDR_OFF		; Get offset
	CMP	AX,INT_OFF
	JNZ	EXIT
;
;	CMP	AX,0600h
;	JNZ	EXIT
	CMP	BX,0700h
	JNZ	EXIT
	CMP	CX,0000h
	JNE	EXIT
;
	MOV	BX,ADDR_SEG
	ADD	BX,DISPLACEMENT
	MOV	DS,BX

; Change the number at next line to the offset of the address to be changed
	MOV	BX,CHANGE_OFF		; New offset of change
	MOV	AX,9090h		; Byte to be changed
	MOV	[BX],AX
;	MOV	AX,9090h
;	MOV	BX[2],AX
;	MOV	BX[4],AL

	POP	ES
	POP	DS
	POP	DI
	POP	SI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	BP
	IRET

EXIT:	POP	ES
	POP	DS
	POP	DI
	POP	SI
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	POP	BP

	JMP	dword ptr  cs:OLDINT	; Jump to oldint
NEWINT ENDP

;----------------------------------------------------------

FINISH		equ	$
MESSAGE		DB	'This is a resident crack by  P.A.C.Man',CR,LF,BEEP,EOS
CHECKSUM	DW	0

INITCODE:
	MOV	AX,CS
	MOV	DS,AX

	PUSH	AX
	PUSH	CX
	PUSH	DX
	PUSH	SI
	PUSH	DS
	LEA	SI,DS:MESSAGE
	LEA	CX,DS:CHECKSUM
	SUB	CX,SI
	MOV	DX,0
checkloop:
	LODSB
	XOR	AL,0ABh
	MOV	AH,00h
	ADD	DX,AX
	LOOP	checkloop
	CMP	DL,0F0h
	JNE	error
	CMP	DH,01Eh
	JNE	error

	POP	DS
	POP	SI
	POP	DX
	POP	CX
	POP	AX

	MOV	AH,09h
	MOV	DX,offset MESSAGE
	INT	21h

	MOV	AH,35h
	MOV	AL,INTERRUPT
	INT	21h
	MOV	OLDINT[0],BX
	MOV	OLDINT[2],ES

	MOV	AH,25h
	MOV	AL,INTERRUPT
	MOV	DX,offset NEWINT
	INT	21h

	LEA	DX,FINISH
	INT	27h
error:
	INT	20h
OVERLAY ENDS
	end START
