#include <io.h>
#include <stdio.h>
#include <dir.h>
#include <string.h>
#include <stdlib.h>

int ozone=42,opoint=0;

struct smsg
 {
  char from[36];
  char to[36];
  char subj[72];
  char date[20];
  int timesread,
      destnode,
      orignode,
      cost,
      orignet,
      destnet,
      destzone,
      origzone,
      destpoint,
      origpoint,
      replyto,
      attribute,
      nextreply;
 }
  msg;

int strip_kukac = 0;

//-----------------------------------------------------------------------

void inshely( FILE *f,long ipos, int len )
{
 char bufx[5000];
 fseek(f,0,SEEK_END);
 long fs=ftell(f);
 long left,curr,b,e;
 long p1,p2;

 if (len==0)
  return;

 if (len<0)
  {
   left=fs-ipos+len;
   p1=ipos;
   while (left>0)
    {
     curr=(left>5000)?5000:left;
     fseek(f,p1-len,SEEK_SET);
     fread(bufx,curr,1,f);

     fseek(f,p1,SEEK_SET);
     fwrite(bufx,curr,1,f);

     left-=curr;
     p1+=curr;
    }

   chsize(fileno(f),fs+len); // itt len < 0, ezert +
   return;
  }

 left=fs-ipos;
 p1=fs;
 while (left>0)
  {
   curr=(left>5000)?5000:left;
   p1-=curr;
   fseek(f,p1,SEEK_SET);
   fread(bufx,curr,1,f);

   fseek(f,p1+len,SEEK_SET);
   fwrite(bufx,curr,1,f);

   left-=curr;
  }
}

void procmsg( char *fname )
{
 FILE *f;
 char *sf;
 char *p,*q;
 char *r,*re;
 char buf[100];
 char ibuf[200];
 char ie[40];
 int fg,rex;
 int zone,net,node,point;
 int disp;

 if (!(f=fopen(fname,"r+b")))
  {
   printf("Couldn't open file %s!\n",fname);
   return;
  }

 sf=&fname[strlen(fname)-1];
 while (sf>fname && (*sf!='\\'))
  sf--;
 if (*sf=='\\')
  sf++;

 fread(&msg,sizeof(msg),1,f);
 printf("Processing %s...",sf);

 if (msg.destnode==0 && msg.destnet==0)
  {
   printf("0:0/0 type...");

   strncpy(buf,msg.to,36); buf[36]=0;

   fg=0;
   if (p=strchr(buf,'@'))
    {
     rex=strlen(p);

     q=strtok(p+1,":");
     if (q)
      {
       zone=atoi(q);
       q=strtok(NULL,"/");
       if (q && zone)
        {
         net=atoi(q);
         q=strtok(NULL,".");
         node=atoi(q);
         fg=1;
         q=strtok(NULL," "); // akarmi
         if (q)
          point=atoi(q);
         else
          point=0;

         if (strip_kukac)
          {
           p=strchr(msg.to,'@');
           memset(p,0,rex);
         //*p='\0'; akkor kene, ha a cimzett-bol le akarjuk vagni a @XX.XX/XX-t
          }
        }
      }
    }

   if (fg)
    {
     printf("--> %d:%d/%d.%d\n",zone,net,node,point);
     msg.destzone=zone;
     msg.destnet=net;
     msg.destnode=node;
     msg.destpoint=point;

     fseek(f,sizeof(msg),SEEK_SET);
     //disp=ftell(f);
     for ( r=buf,*r=0;
       ((*r=fgetc(f))!=EOF) && (*r!='\n') && (*r!='\r') ;
         r++ ) ;
     *(r+1)=0;
     //fgets(buf,99,f);
     strupr(buf);
     disp=0;
     if (strncmp(buf,"\x1INTL ",6)==0)
      {
       p=strtok(buf+6," ");
       p=strtok(NULL,","); // kamura
       strcpy(ie,p);
       disp=ftell(f)-sizeof(msg);
      }

     sprintf(ibuf,"\x1INTL %d:%d/%d ",zone,net,node);
     if (disp)
      strcpy(buf,ie);
     else
      sprintf(buf,"%d:%d/%d\r\n",msg.origzone,msg.orignet,msg.orignode);
     strcat(ibuf,buf);

     if (point)
      {
       sprintf(buf,"\x1TOPT %d\r\n",point);
       strcat(ibuf,buf);
      }

     if (opoint)
      {
       sprintf(buf,"\x1FMPT %d\r\n",point);
       strcat(ibuf,buf);
      }

     fseek(f,0,SEEK_SET);
     fwrite(&msg,sizeof(msg),1,f);

     inshely(f,sizeof(msg)+disp,strlen(ibuf)-disp);
     fseek(f,sizeof(msg),SEEK_SET);
     fwrite(ibuf,strlen(ibuf),1,f);
    }
   else
    {
     printf("no @/not correct addr. in TO field\n");
    }
  }
 else
  {
   printf("ok\n");
  }
 fclose(f);
}

void findit( char *cpath )
{
 struct ffblk ffblk;
 int done;
 char buf[128];

 sprintf(buf,"%s\\*.msg",cpath);
 done = findfirst(buf,&ffblk,0);
 while (!done)
  {
   sprintf(buf,"%s\\%s",cpath,ffblk.ff_name);
   procmsg(buf);
   done = findnext(&ffblk);
  }
}


int main( int argc, char **argv )
{
 printf("Ŀ\n"
        " .MSG-izbigy v1.1beta (C) 1997, John Zero/NSS \n"
        "\n");

 if (argc<=1)
  {
   printf("Parameter: <directory-of-.MSGS> [s]\n"
          " s - strip address (after @) form Name@XX:YYY/ZZ\n"
          "\n"
          "Example: MSGCSEL C:\MSGS s\n"
          "\n"
          "Help/comments: mailto: john@graphisoft.hu\n"
         );
   return 1;
  }

 if (argc>1)
  {
   printf("Options: ");
   if (argv[2][0]=='s')
    { strip_kukac=1; printf("Strip@ "); }

   printf("\n");
  }
 printf("\n");

 findit(argv[1]);
 return 0;
}
